
// Set XBEE_ROLE to NODE_TYPE_COORD, NODE_TYPE_ROUTER or NODE_TYPE_ENDDEV to
// match your XBee's firmware.  View the function help (Ctrl+H) on XBEE_ROLE
// for additional information on setting up an XBee network.
#define XBEE_ROLE			NODE_TYPE_ROUTER

// Set a Node ID to identify this node on the network.
#define NODEID_STR			"El Rabito"

#memmap xmem

#define DEFAULT_EXTPANID	"0x00"
//#define XBEE_DEBUG
//#define XBEE_VERBOSE
#use "xbee_api.lib"

// ------------------------------------------------------
// The libraries expect to find an endpoint table.  You must define an
// Endpoint table, even if it is empty.  The following macros, along with
// ENDPOINT_TABLE_ENTRY, simplify this procedure.  For more information,
// perform a function lookup (ctrl-H) on ENDPOINT_TABLE_BEGIN.

ENDPOINT_TABLE_BEGIN
ENDPOINT_TABLE_END

rxmsg_handler(void);
txmsg_handler(void);


void main (void)
{
   int retval;
	unsigned long timer;

	// *** Initialization ***

	// Initialize the radio portion of the board
	while ( (retval = xbee_init()) == -EBUSY); // Waiting for sleeping XBee to wake before continuing
	if (retval){
		printf("xbee_init failed.  result code: %d (%ls)\n",retval, error_message(retval));
		exit(retval);
	}
	// Join the network.  For more information on ZB_JOINING_NETWORK,
	// perform a function lookup (ctrl-H) on ZB_LAST_STATUS().
	printf("Waiting to join network...\n");
	timer = MS_TIMER + XBEE_JOIN_TIMEOUT;
	while (ZB_JOINING_NETWORK()) {
		// If unable to join a network, timeout after arbitrary time
		if (MS_TIMER > timer ) {
	      printf("\n*** Error ***\nTimed out while trying to join a network.\n");
	      break;
	   }
	}
	printf("done\n");

	timer = MS_TIMER;


	// *** End Initialization ***

   while(1) {
   	switch(xbee_tick(NULL)){
		case  ZB_NOMESSAGE:		//		no messages received
         break;
		case	ZB_MESSAGE:			//		a message has arrived
      	rxmsg_handler();
         break;
		case  ZB_RADIO_STAT:		//		radio status change
         printf("Radio status change: %s\n", ZB_LAST_STATUS()==ZB_JOINED ?
				"joined" : "unjoined");
         break;
		case  ZB_MSG_STAT:		//		message transmission status available
			printf("Transmission Status received: %d\n",ZB_XMIT_STATUS());
         break;
		case  ZB_ATRESP:			//		response to AT command
         break;
		case  ZB_REMOTE_RESP:	//		response to remote AT command
         break;
		case  -ENOMEM:				//		out of memory processing node discovery
     	default: 					//		an error has occurred
         exit(ZB_ERROR());
         break;
      }
		if (MS_TIMER > timer ) {
			timer = MS_TIMER + 2000;
      	printf( "!");
	      txmsg_handler();
		}
	}
}


rxmsg_handler(void)
{
api_frame_t *myframe;
static unsigned char rxmsg[256];
static int rxlen;

	if(zb_receive(rxmsg,&rxlen)){
		printf("\nRX: %d bytes\n\t",rxlen);
   	xb_hexdump(rxmsg,rxlen);
      zb_reply("Gracias!",8);
   }
}

txmsg_handler()
{
zb_sendAddress_t addr;
static unsigned char txmsg[85],seq;

// broadcast
	zb_MakeIEEENetworkAddr(-1,&addr);

	strcpy(txmsg,"ALARMA!!!");
   addr.msg=txmsg;
   addr.msglen=strlen(txmsg);
	zb_send(&addr);
}