
// Set XBEE_ROLE to NODE_TYPE_COORD, NODE_TYPE_ROUTER or NODE_TYPE_ENDDEV to
// match your XBee's firmware.  View the function help (Ctrl+H) on XBEE_ROLE
// for additional information on setting up an XBee network.
#define XBEE_ROLE			NODE_TYPE_ROUTER

// Set a Node ID to identify this node on the network.
#define NODEID_STR			"El Rabito"

#memmap xmem

#define DEFAULT_EXTPANID	"0x00"
//#define XBEE_DEBUG
//#define XBEE_VERBOSE
#use "xbee_api.lib"

// ------------------------------------------------------
// The libraries expect to find an endpoint table.  You must define an
// Endpoint table, even if it is empty.  The following macros, along with
// ENDPOINT_TABLE_ENTRY, simplify this procedure.  For more information,
// perform a function lookup (ctrl-H) on ENDPOINT_TABLE_BEGIN.

ENDPOINT_TABLE_BEGIN
ENDPOINT_TABLE_END



void main (void)
{
   int retval;
	unsigned long reg;

	// *** Initialization ***

	// Initialize the radio portion of the board
	while ( (retval = xbee_init()) == -EBUSY); // Waiting for sleeping XBee to wake before continuing
	if (retval){
		printf("xbee_init failed.  result code: %d (%ls)\n",retval, error_message(retval));
		exit(retval);
	}

	// *** End Initialization ***

   if(!xb_get_register(xb_JV,&reg)) {
   	printf("JV=%lu\n",reg);
      reg=1;
      if(!xb_set_register(xb_JV,reg)){
		   if(!xb_get_register(xb_JV,&reg))
   			printf("JV=%lu\n",reg);
      }
   }
}