
// Set XBEE_ROLE to NODE_TYPE_COORD, NODE_TYPE_ROUTER or NODE_TYPE_ENDDEV to
// match your XBee's firmware.  View the function help (Ctrl+H) on XBEE_ROLE
// for additional information on setting up an XBee network.
#define XBEE_ROLE			NODE_TYPE_ROUTER

// Set a Node ID to identify this node on the network.
#define NODEID_STR			"El Rabito"

#memmap xmem

#define DEFAULT_EXTPANID	"0x00"
//#define XBEE_DEBUG
//#define XBEE_VERBOSE
#use "xbee_api.lib"

// ------------------------------------------------------
// The libraries expect to find an endpoint table.  You must define an
// Endpoint table, even if it is empty.  The following macros, along with
// ENDPOINT_TABLE_ENTRY, simplify this procedure.  For more information,
// perform a function lookup (ctrl-H) on ENDPOINT_TABLE_BEGIN.

ENDPOINT_TABLE_BEGIN
ENDPOINT_TABLE_END

txmsg_handler(void);


void main (void)
{
   int retval;
	unsigned long timer;
	zb_sendAddress_t addr;
	static unsigned char txmsg[85],seq;

	const static char destaddr[8] = {0x00,0x13,0xA2,0x00,0x40,0x0A,0x5E,0x3A};
   const static char remdata[1]= {0x05};

	// *** Initialization ***

	// Initialize the radio portion of the board
	while ( (retval = xbee_init()) == -EBUSY); // Waiting for sleeping XBee to wake before continuing
	if (retval){
		printf("xbee_init failed.  result code: %d (%ls)\n",retval, error_message(retval));
		exit(retval);
	}
	// Join the network.  For more information on ZB_JOINING_NETWORK,
	// perform a function lookup (ctrl-H) on ZB_LAST_STATUS().
	printf("Waiting to join network...\n");
	timer = MS_TIMER + XBEE_JOIN_TIMEOUT;
	while (ZB_JOINING_NETWORK()) {
		// If unable to join a network, timeout after arbitrary time
		if (MS_TIMER > timer ) {
	      printf("\n*** Error ***\nTimed out while trying to join a network.\n");
	      break;
	   }
	}
	printf("done\n");

	// *** End Initialization ***

	xb_sendAPIremoteATcmd(destaddr, ZB_NETWORK_BROADCAST,XB_REMOTE_REQ_OPT_APPLY,xb_P1,remdata,sizeof(remdata));

	while(1)
   	xbee_tick(NULL);

}

