// frame types
#define API_APISEND64	0x00
#define API_APISEND16	0x01
#define API_APISNDSTS	0x89
#define API_APIRECV64	0x80
#define API_APIRECV16	0x81
#define API_APIIORECV64	0x82
#define API_APIIORECV16	0x83

// send options
#define SOP_NOACK	0x01
#define SOP_BCASTPAN	0x04

// send status
#define SST_SUCCESS	0
#define SST_NOACK	1
#define SST_CCAFAILURE	2
#define SST_PURGED	3

// receive options
#define ROP_ABCAST	(1<<1)
#define ROP_PBCAST	(1<<2)

typedef struct {
	unsigned char frameid;
	unsigned char addr[2];
	unsigned char options;
	unsigned char data;
} APIsend16;

typedef struct {
	unsigned char frameid;
	unsigned char addr[8];
	unsigned char options;
	unsigned char data;
} APIsend64;

typedef struct {
	unsigned char frameid;
	unsigned char status;
} APIsendsts;

typedef struct {
	unsigned char addr[2];
	unsigned char rssi;
	unsigned char options;
	unsigned char data;
} APIrecv16;

typedef struct {
	unsigned char addr[8];
	unsigned char rssi;
	unsigned char options;
	unsigned char data;
} APIrecv64;

#include "IOdata.h"
typedef struct {
	unsigned char samples;
	unsigned char channel[2];
	IOdata iodata;
} APIiorecv;

typedef struct {
	unsigned char addr[2];
	unsigned char rssi;
	unsigned char options;
	APIiorecv data;
} APIiorecv16;

typedef struct {
	unsigned char addr[8];
	unsigned char rssi;
	unsigned char options;
	APIiorecv data;
} APIiorecv64;

typedef struct {
	unsigned char addr16[2];
	unsigned char addr64[8];
	unsigned char rssi;
	unsigned char ID;
} APInodeID;


