#include <stdio.h>

#include "apiframe.h"
#include "apicommon.h"
#include "api15_4.h"
#include "monlib.h"
#include "monlib15_4.h"

int TX(unsigned char data)
{
}

int RX()
{
  int wword;
  char c,d;

	c=getchar();
	if((c<'0')||(c>'F'))
      		return(-1);
    	if((c>'9')&&(c<'A'))
		return(-1);
	if(c>='A')
      		c=c-7;
	d=c-'0';
        c=getchar();
        if((c<'0')||(c>'F'))
                return(-1);
        if((c>'9')&&(c<'A'))
                return(-1);
        if(c>='A')
                c=c-7;
	c-='0';
        return((d<<4)+c);
}


main (int argc, char *argv[])
{

static APIstruct api,apirx;
static APIdata rxdata;
APIinfo *info;
APIstatus *sts;
APIcommand *cmd;
APIresponse *resp;
APIrmtcmd *rcmd;
APIrmtrsp *rresp;
APIsend16 *s16;
APIsend64 *s64;
APIsendsts *ssts;
APIrecv16 *r16;
APIrecv64 *r64;
APIiorecv *ior;
APIiorecv16 *ior16;
APIiorecv64 *ior64;
char *ptr,buff[150];
int i,l,ret;
unsigned char escape;

    if(argc!=2){
      fprintf(stderr,"usage: %s mode\n\tmode=1: escaped chars\n\tmode=0: non-escaped chars\n",argv[0]);
      exit (-1);
    }	
    escape=(*argv[1]=='1');
    
  API_initgettingframe(&apirx);

  while(1){
    while((ret=API_getframe(&apirx,escape))<=0);
    rxdata.len=ret;
    memcpy(&rxdata.info,&apirx.frame.info,ret);
    info=&rxdata.info;
    printf("\nRX: ");
    prdata((unsigned char *)info,rxdata.len,1);
    printf("\n");
    switch(info->id){
    case API_APISTATUS:
      sts=(APIstatus *)&info->data;
      printf("Status frame: %s (%02X)\n",prsts(sts->status),sts->status);
      break;
    case API_APIQCOMMAND:
      printf("Queue ");
    case API_APICOMMAND:
      cmd=(APIcommand *)&info->data;
      printf("Command frame: ID: %02X CMD: %c%c PARAM: ",cmd->frameid,cmd->cmd[0],cmd->cmd[1]);
      prdata(&cmd->param,rxdata.len-4,0);
      printf("\n");
      break;
    case API_APIRESPONSE:
      resp=(APIresponse *)&info->data;
      printf("Command Response frame: ID: %02X STS: %s (%02X) DATA: ",resp->frameid,prrst(resp->status),resp->status);
      prdata(&resp->data,rxdata.len-5,0);
      printf("\n");
      break;
    case API_APIRMTCMD:
      rcmd=(APIrmtcmd *)&info->data;
      printf("Remote Command frame: ID: %02X\n",rcmd->frameid);
      priaddr(rcmd->addr64);
      prsaddr(rcmd->addr16);
      if(rcmd->options&RCO_APPLY)
	printf("\nAPPLY ");
      else
	printf("\n");
      printf("CMD: %c%c PARAM: ",rcmd->cmd[0],rcmd->cmd[1]);
      prdata(&rcmd->param,rxdata.len-4,0);
      printf("\n");
      break;
    case API_APIRMTRSP:
      rresp=(APIrmtrsp *)&info->data;
      printf("Remote Command Response frame: ID: %02X\n",resp->frameid);
      priaddr(rresp->addr64);
      prsaddr(rresp->addr16);
      printf("STS: %s (%02X) DATA: ",prrst(rresp->status),rresp->status);
      prdata(&rresp->data,rxdata.len-5,0);
      printf("\n");
      break;
    case API_APISEND64:
      s64=(APIsend64 *)&info->data;
      printf("Data Send, 64-bit address: ID: %02X ADDR: ",s64->frameid);
      prdata(s64->addr,8,1);
      printf(" OPT: %s (%02X) DATA: ",prsop(s64->options),s64->options);
      prdata(&s64->data,rxdata.len-11,0);
      printf("\n");
      break;
    case API_APISEND16:
      s16=(APIsend16 *)&info->data;
      printf("Data Send, 16-bit address: ID: %02X ADDR: %02X%02X OPT: %s (%02X) DATA: ",s16->frameid,s16->addr[0],s16->addr[1],prsop(s16->options),s16->options);
      prdata(&s16->data,rxdata.len-5,0);
      printf("\n");
      break;
    case API_APISNDSTS:
      ssts=(APIsendsts *)&info->data;
      printf("Send Status frame: ID: %02X STS: %s (%02X)\n",ssts->frameid,prsst(ssts->status),ssts->status);
      break;
    case API_APIRECV64:
      r64=(APIrecv64 *)&info->data;
      printf("Data Receive, 64-bit address: ADDR: ");
      prdata(r64->addr,8,1);
      printf("RSSI: %02X OPT: %s (%02X) DATA: ",r64->rssi, prrop(r64->options),r64->options);
      prdata(&r64->data,rxdata.len-11,0);
      printf("\n");
      break;
    case API_APIRECV16:
      r16=(APIrecv16 *)&info->data;
      printf("Data Receive, 16-bit address: ADDR: %02X%02X RSSI: %02X OPT: %s (%02X) DATA: ",r16->addr[0],r16->addr[1],r16->rssi,prrop(r16->options),r16->options);
      prdata(&r16->data,rxdata.len-5,0);
      printf("\n");
      break;
    case API_APIIORECV64:
      ior64=(APIiorecv64 *)&info->data;
      ior=&ior64->data;
      printf("I/O Data Receive, 64-bit address: ADDR: ");
      prdata(ior64->addr,8,1);
      printf("RSSI: %02X OPT: %s (%02X)\n",ior64->rssi,prrop(ior64->options),ior64->options);
      priodata(ior);
      break;
    case API_APIIORECV16:
      ior16=(APIiorecv16 *)&info->data;
      ior=&ior16->data;
      printf("I/O Data Receive, 16-bit address: ADDR: %02X%02X RSSI: %02X OPT: %s (%02X)\n",ior16->addr[0],ior16->addr[1],ior16->rssi,prrop(ior16->options),ior16->options);
      priodata(ior);
      break;
    default:
      printf("*** UNKNOWN FRAME\n");
    }
    printf("\n");
  }
}



