#include "api15_4.h"

const unsigned char *prsop(unsigned char sop)
{

  switch(sop){
  case SOP_NOACK:
    return("NOACK");
  case SOP_BCASTPAN:
    return("BCASTPAN");
  case 0:
    return("NONE");
  default:
    return("?");
  }
}

const unsigned char *prsst(unsigned char sts)
{
static const char* stss[]={"SUCCESS","NOACK","CCA_FAILURE","PURGED"};

  if(sts<=SST_PURGED)
    return(stss[sts]);
  else
    return("?");
}

unsigned char *prrop(unsigned char rop)
{
static unsigned char pepe[128],aux;

  pepe[0]=0;
  aux=rop;
  if(rop&ROP_ABCAST){
    strcat(pepe,"ADDRESS");
    rop&=~ROP_ABCAST;
    if(rop)
      strcat(pepe,"+");
  }
  if(rop&ROP_PBCAST){
    strcat(pepe,"PAN");
    rop&=~ROP_PBCAST;
    if(rop)
      strcat(pepe,"+");
  }
  if(rop)
    strcat(pepe,"?");
  if(aux&(ROP_ABCAST|ROP_PBCAST))
    strcat(pepe," BROADCAST");
  else if(!aux)
    strcpy(pepe,"NONE");
  
  return(pepe);
}

priodata(APIiorecv *io)
{
int i,j;
IOdata *iod;
unsigned char aux,mask=1,ch=0,cur;
  
  aux=io->channel[0]&0x7E;
  aux>>=1;
  while(mask){
    if(aux&mask)
      ch++;
    mask<<=1;
  }
  iod=&io->iodata;
  printf("%d samples, active channels: %02X %02x\n",io->samples,io->channel[0],io->channel[1]);

  for(i=0;i<io->samples;i++){
    printf("\t");
    if(io->channel[1]|(io->channel[0]&1)){
      printf("I/O: %X%02X  ",iod->data[0]&1,iod->data[1]);
      iod++;
    }
    mask=1;
    cur=0;
    for(j=0;j<ch;j++){
      while(!(aux&mask)){
	mask<<=1;
	cur++;
	if(!mask)
	  break;
      }
      printf("AN%c: %X%02X  ",cur+'0',iod->data[0]&3,iod->data[1]);
      iod++;
      cur++;
      mask<<=1;
    }
    printf("\n");
  }
}
