#include <stdio.h>
#include <sys/types.h>

#include "apiframe.h"
#include "apicommon.h"
#include "apizb.h"
#include "monlib.h"
#include "monlibzb.h"

int efede;

int TX(unsigned char data)
{
  write(efede,&data,1);
  return(1);
}

int RX()
{
unsigned char c;
  
  if(read(efede,&c,1)<=0)  // wait for a char in serial input
    return(-1);
  else return(c);
}



main (int argc, char *argv[])
{

int ret=0,parent,shrt;
long lng1,lng2;
static APIstruct api,apirx;
static APIdata rxdata;
APIinfo *info;
APIstatus *sts;
APIcommand *cmd;
APIresponse *resp;
APIznodeID *id;
APIznodeID2 *id2;
unsigned char escape;
int pspeed=0;

FILE *dot;
time_t t,timeout;

char label[64];

    if(argc!=4){
      fprintf(stderr,"usage: %s mode port speed\n",argv[0]);
      fprintf(stderr,"\tmode=1: escaped chars\n\tmode=0: non-escaped chars\n");
      exit (-1);
    }
    escape=(*argv[1]=='1');
    pspeed=atoi(argv[3]);
    if(pspeed){
      efede=set_up_comms(argv[2],pspeed,"none");
      /* disable buffering so we can see output in realtime */
      setvbuf(stdout,(char *)NULL,_IONBF,0);
    }
    else exit(-1);
    
   dot=fopen("nd.dot","w");
   fprintf(dot,"digraph A {\nsize=\"8,11\"\nratio=compress\nrotate=90\n");

    api.frame.info.id=API_APICOMMAND;
    cmd=(APIcommand *)&api.frame.info.data;
    cmd->frameid=0x12;
    cmd->cmd[0]='N';
    cmd->cmd[1]='D';
    API_buildframe(&api,sizeof(APIcommand)+1-1);
    prdata((char *)&api.frame,api.len,1);
    API_initsendingframe(&api);
    while(API_sendframe(&api,0)==API_AGAIN);
    
  API_initgettingframe(&apirx);
  time(&t);
  timeout=t+(time_t)10;
  while(!ret){
    while((ret=API_getframe(&apirx,escape))<=0){
	sleep(1);
          time(&t);
          if(t>timeout)
		goto chau;
    }
    rxdata.len=ret;
    memcpy(&rxdata.info,&apirx.frame.info,ret);
    API_initgettingframe(&apirx);
    info=&rxdata.info;
    printf("\nRX: ");
    prdata((unsigned char *)info,rxdata.len,1);
    printf("\n");
    switch(info->id){
    case API_APISTATUS:
      sts=(APIstatus *)&info->data;
      printf("Status frame: %s (%02X)\n",prsts(sts->status),sts->status);
      break;
    case API_APIQCOMMAND:
      printf("Queue ");
    case API_APICOMMAND:
      cmd=(APIcommand *)&info->data;
      printf("Command frame: ID: %02X CMD: %c%c PARAM: ",cmd->frameid,cmd->cmd[0],cmd->cmd[1]);
      prdata(&cmd->param,rxdata.len-4,0);
      printf("\n");
      break;
    case API_APIRESPONSE:
      resp=(APIresponse *)&info->data;
      printf("Command Response frame: ID: %02X STS: %s (%02X) DATA: ",resp->frameid,prrst(resp->status),resp->status);
      prdata(&resp->data,rxdata.len-5,0);
      printf("\n");
	ret=0;
      id=(APIznodeID *)&resp->data;
	prznodeid(id);
	id2=(APIznodeID2 *) (&id->id1.ID+strlen(&id->id1.ID)+1);
	parent=(id2->parent[0]<<8)+id2->parent[1];
        shrt=(id->id1.addr16[0]<<8)+id->id1.addr16[1];
        lng1=(id->id1.addr64[0]<<24)+(id->id1.addr64[1]<<16)+(id->id1.addr64[2]<<8)+(id->id1.addr64[3]<<0);
        lng2=(id->id1.addr64[4]<<24)+(id->id1.addr64[5]<<16)+(id->id1.addr64[6]<<8)+(id->id1.addr64[7]<<0);
	sprintf(label,"%s\\n%08lX%08lX\\n(%04X)",&id->id1.ID,lng1,lng2,shrt);
	switch(id2->type){
	case ZID_DTCOORD:
        	fprintf(dot,"n%04X [shape=house label=\"%s\" color=blue style=filled fillcolor=red fontcolor=green fontsize=8];\n",shrt,label);
		break;
	case ZID_DTROUTER:
		fprintf(dot,"n%04X [shape=circle label=\"%s\" color=red style=solid fontcolor=green fontsize=6];\n",shrt,label);
		break;
	case ZID_DTENDDEV:
                fprintf(dot,"n%04X [shape=diamond label=\"%s\" color=blue style=solid fontcolor=green fontsize=6];\n",shrt,label); 
		fprintf(dot,"n%04X -> n%04X [label=\"\" color=black style=dashed dir=none];\n",parent,shrt);
		break;
	default:
                fprintf(dot,"n%04X [shape=egg label=\"%s\\n????\" color=cyan style=filled fontcolor=green fontsize=6];\n",shrt,label);
		break;
	}
      break;
    default:
      ret=0;
    }
    printf("\n");
  }
chau:    fprintf(dot,"}\n");
  fclose(dot);
}

